/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg2013440041;

import aeat.AEATType;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Rectangle;
import java.util.HashMap;
import java.util.Map;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

/**
 *
 * @author djj94
 */
// Jpanel 을 사용하는 AeaPanel 선언
public class AeaPanel extends JPanel {

    private MyButtonActionListener buttonActionListener;
    private Map<String, JTextField> nameToTextField;
    private Map<String, JComboBox> nameToComboBox;
    private Map<String, JRadioButton> nameToRadioButton;
    // 버튼 리스너와 nanmeToTextField 의 Map 을 선언한다.

    // AeaPanel 이 선언되면 동작하는 코드.
    public AeaPanel(MyButtonActionListener buttonActionListener) {
        super();
        super.setMinimumSize(new Dimension(400, 150));
        super.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        super.setBorder(BorderFactory.createTitledBorder("Aea"));
        // 사이즈와 레이아웃, Border 설정을 한다.

        this.buttonActionListener = buttonActionListener;
        nameToTextField = new HashMap<>();
        nameToComboBox = new HashMap<>();
        nameToRadioButton = new HashMap<>();
        
        initComponents();
        // initComponents() 실행
    }

    // initComponents()
    // 입력 : 없음
    // 출력 : 없음
    // 부수효과 : 패널에 createRecord() 의 결과값이 실행된다.
    private void initComponents() {
        this.add(createRecord("aeaId"));
        this.add(createRecord("issuer"));
        this.add(createChoice("audience"));
        this.add(createChoice("aeaType"));
        this.add(createRecord("refAEAId"));
        this.add(createRadio("priority"));
        this.add(createRadio("wakeup"));
    }

    private Box createRadio(String name) {
        Box box = Box.createHorizontalBox();
        JPanel hole = new JPanel();
        hole.setMinimumSize(new Dimension(400, 20));

        JLabel label = new JLabel(name, JLabel.CENTER);
        label.setFont(Frame.LABEL_FONT);
        label.setPreferredSize(Frame.LABEL_DIMENSION);
        box.add(label);

        box.add(Box.createHorizontalGlue());

        if (name.equals("wakeup")) {
            JRadioButton trueRadio = new JRadioButton("TRUE");
            trueRadio.setFont(Frame.LABEL_FONT);
            JRadioButton falseRadio = new JRadioButton("FALSE");
            falseRadio.setFont(Frame.LABEL_FONT);
            ButtonGroup buttonGroup = new ButtonGroup();
            buttonGroup.add(trueRadio);
            buttonGroup.add(falseRadio);

            box.add(trueRadio);
            box.add(hole);
            box.add(falseRadio);
            box.add(hole);
            nameToRadioButton.put("wakeUpTrue", trueRadio);
            nameToRadioButton.put("wakeUpFalse", falseRadio);

        } else if (name.equals("priority")) {
            JRadioButton radio0 = new JRadioButton("VeryLow");
            radio0.setFont(Frame.LABEL_FONT);
            JRadioButton radio1 = new JRadioButton("Low");
            radio1.setFont(Frame.LABEL_FONT);
            JRadioButton radio2 = new JRadioButton("Normal");
            radio2.setFont(Frame.LABEL_FONT);
            JRadioButton radio3 = new JRadioButton("High");
            radio3.setFont(Frame.LABEL_FONT);
            JRadioButton radio4 = new JRadioButton("VeryHigh");
            radio4.setFont(Frame.LABEL_FONT);
            ButtonGroup buttonGroup = new ButtonGroup();
            buttonGroup.add(radio0);
            buttonGroup.add(radio1);
            buttonGroup.add(radio2);
            buttonGroup.add(radio3);
            buttonGroup.add(radio4);
            

            box.add(radio4);
            box.add(hole);
            box.add(radio3);
            box.add(hole);
            box.add(radio2);
            box.add(hole);
            box.add(radio1);
            box.add(hole);
            box.add(radio0);
            box.add(hole);

            nameToRadioButton.put("priority0", radio0);
            nameToRadioButton.put("priority1", radio1);
            nameToRadioButton.put("priority2", radio2);
            nameToRadioButton.put("priority3", radio3);
            nameToRadioButton.put("priority4", radio4);
        }

        return box;

    }

    private Box createChoice(String name) {
        Box box = Box.createHorizontalBox();
        JComboBox combo = new JComboBox();
        JLabel label = new JLabel(name, JLabel.CENTER);
        label.setFont(Frame.LABEL_FONT);
        label.setPreferredSize(Frame.LABEL_DIMENSION);
        box.add(label);
        if (name.equals("audience")) {
            combo.addItem("public");
            combo.addItem("restricted");
            combo.addItem("private");
        } else if (name.equals("aeaType")) {
            combo.addItem("alert");
            combo.addItem("update");
            combo.addItem("cancel");
        } else if (name.equals("priority")) {
            combo.addItem("4");
            combo.addItem("3");
            combo.addItem("2");
            combo.addItem("1");
            combo.addItem("0");
        }
        box.add(combo);
        nameToComboBox.put(name, combo);
        return box;
    }

    // createRecord()
    private Box createRecord(String name) {
        Box box = Box.createHorizontalBox();
        JLabel label = new JLabel(name, JLabel.CENTER);
        label.setFont(Frame.LABEL_FONT);
        label.setPreferredSize(Frame.LABEL_DIMENSION);
        box.add(label);

        box.add(Box.createHorizontalGlue());

        JTextField textField = new JTextField("");
        box.add(textField);

        nameToTextField.put(name, textField);
        return box;
    }

    public void loadAeat(AEATType aeat) {
        nameToTextField.get("aeaId").setText(aeat.getAEA().get(0).getAeaId());
        nameToTextField.get("issuer").setText(aeat.getAEA().get(0).getIssuer());
        nameToComboBox.get("audience").setSelectedItem(aeat.getAEA().get(0).getAudience().value());
        nameToComboBox.get("aeaType").setSelectedItem(aeat.getAEA().get(0).getAeaType().value());
        nameToTextField.get("refAEAId").setText(aeat.getAEA().get(0).getRefAEAId());
        
        String priority = aeat.getAEA().get(0).getPriority().toString();
        switch (priority) {
            case "0" : nameToRadioButton.get("priority0").setSelected(true); break;
            case "1" : nameToRadioButton.get("priority1").setSelected(true); break;
            case "2" : nameToRadioButton.get("priority2").setSelected(true); break;
            case "3" : nameToRadioButton.get("priority3").setSelected(true); break;
            case "4" : nameToRadioButton.get("priority4").setSelected(true); break;
            default : break;
        }
        
//        nameToComboBox.get("priority").setSelectedItem(aeat.getAEA().get(0).getPriority().toString());

        String wakeUp = String.valueOf(aeat.getAEA().get(0).isWakeup());
        if (wakeUp.equals("true")) {
            nameToRadioButton.get("wakeUpTrue").setSelected(true);
        } else if (wakeUp.equals("false")) {
            nameToRadioButton.get("wakeUpFalse").setSelected(true);
        }
//        nameToRadioButton.get("wakeup").setText(String.valueOf(aeat.getAEA().get(0).isWakeup()));
    }

    public String getAeaId() {
        return nameToTextField.get("aeaId").getText();
    }

    public String getIssuer() {
        return nameToTextField.get("issuer").getText();
    }

    public String getAudience() {
        return nameToComboBox.get("audience").getSelectedItem().toString();
    }

    public String getAeaType() {
        return nameToComboBox.get("aeaType").getSelectedItem().toString();
    }

    public String getRefAEAId() {
        return nameToTextField.get("refAEAId").getText();
    }

    public String getPriority() {
        if (nameToRadioButton.get("priority0").isSelected()) return "0";
        else if (nameToRadioButton.get("priority1").isSelected()) return "1";
        else if (nameToRadioButton.get("priority2").isSelected()) return "2";
        else if (nameToRadioButton.get("priority3").isSelected()) return "3";
        else if (nameToRadioButton.get("priority4").isSelected()) return "4";
        else return "default";
//        return nameToComboBox.get("priority").getSelectedItem().toString();
    }

    public String isWakeup() {
        if (nameToRadioButton.get("wakeUpTrue").isSelected()) {
            return "true";
        } else if (nameToRadioButton.get("wakeUpFalse").isSelected()) {
            return "false";
        } else {
            return "default";
        }
    }

}
